#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
using namespace std;
const lli INF=20005, MAXN=2005, MAXS=20005;
lli S, N, a[MAXN], dp[MAXS];
lli f(lli x){
    if(x==0)return 0;
    if(x==1)return 1;
    if(dp[x]!=0)return dp[x];
    dp[x]=INF;
    for(lli i=0; i<N; i++){
        if(x-a[i]>=0)dp[x]=min(dp[x], f(x-a[i])+1);
        else break;
    }
    return dp[x];
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>S>>N;
    dp[1]=1;
    for(lli i=0; i<N; i++)cin>>a[i];
    sort(a, a+N);
    cout<<f(S)<<endl;
    return 0;
}
